/* aps 7may03  */
#include <stdlib.h>
#include <stdio.h>
#include <glut.h>  /* #include <gl\glut.h>  */
#include <sys/time.h> /* #include <sys/timeb.h>  */
#include <math.h>
#define  MAX(x,y)         (((x)<(y))?(y):(x))
#define  MIN(x,y)         (((x)<(y))?(x):(y))
#define  CLAMP(x,u,v)     (x<u? u : (x>v ? v: x))
#define  ABS(u)           ((u)<0 ? -(u): (u))
#define  FOR(a,b,c)       for((a)=(b);(a)<(c);(a)++)
#define  DOT(p,q)         ((p)[0]*(q)[0]+(p)[1]*(q)[1]+(p)[2]*(q)[2])
#define  NRM(p)           sqrt(DOT((p),(p)))
#define  DG            M_PI/180
#define  S(u)          sin(u*DG)
#define  C(u)          cos(u*DG)
#define  CLAMP(x,u,v) (x<u? u : (x>v ? v: x))
#define RND ((float)rand()/RAND_MAX)         /* random fraction */
#define IFCLICK(K,a){static ff=1; if(getbutton(K))ff=1-ff; if(ff){a} }

#define mmax 50
#define MANY 1048576 
#define NN   10     /* 4^10 = 1048576  */
float AA[MANY][2];  /* buffer for 4^10 points */ 
float aa[4]={0.79, -.12, .18, 0.};
float bb[4]={-0.42, 0.26, -0.14, 0.};
float cc[4]={0.24, 0.15, 0.09, 0.};
float dd[4]={.86, .05, .18, 0.};
float ee[4]={0.176, -0.672, 0.609, 0.};
float ff[4]={0.141, .138, .157, 0.};
int mm=0;
/***********************************************************/
void loadA(void){ int kk;   /* with random fractional coords*/
FOR(kk,0,MANY){AA[kk][0]=RND; AA[kk][1]=RND;} 
}
/***********************************************************/
void zeroA(void){ int kk;   /* with random fractional coords*/
FOR(kk,0,MANY){AA[kk][0]=AA[kk][1]=0;} 
}
/***********************************************************/
void testdisplay(){ int kk;
  FOR(kk,0,MANY){  
      glBegin(GL_POINTS);                 /* draw a */
        glColor3f(1.0,1.0,1.0);
        glVertex2fv(AA[kk]);                  /* point  */
      glEnd();
  }
}
/***********************************************************/
void display(){  int uu,kk,top;
  
  FOR(uu,0,NN){ top = (int)pow(4,uu);   /* top of stack */
  FOR(kk,0,top){
  AA[top + 3*kk][0]  = aa[1]*AA[kk][0]+bb[1]*AA[kk][1]+ee[1];
  AA[top + 3*kk][1]  = cc[1]*AA[kk][0]+dd[1]*AA[kk][1]+ff[1];
  AA[top + 3*kk+1][0]= aa[2]*AA[kk][0]+bb[2]*AA[kk][1]+ee[2];
  AA[top + 3*kk+1][1]= cc[2]*AA[kk][0]+dd[2]*AA[kk][1]+ff[2];
  AA[top + 3*kk+2][0]= aa[3]*AA[kk][0]+bb[3]*AA[kk][1]+ee[3];
  AA[top + 3*kk+2][1]= cc[3]*AA[kk][0]+dd[3]*AA[kk][1]+ff[3];
  AA[kk][0]          = aa[0]*AA[kk][0]+bb[0]*AA[kk][1]+ee[0];
  AA[kk][1]          = cc[0]*AA[kk][0]+dd[0]*AA[kk][1]+ff[0];
      glBegin(GL_POINTS);
        glColor3f(1.0,1.0,1.0);
        glVertex2fv(AA[kk]);
        glVertex2fv(AA[top+3*kk]);
        glVertex2fv(AA[top+3*kk+1]);
        glVertex2fv(AA[top+3*kk+2]);
      glEnd();
  }}
 
  if (mm<mmax) {
    aa[0]-=.457/mmax; aa[1]+=.287/mmax; aa[2]-=.013/mmax; aa[3]+=.333/mmax;
    bb[0]+=0.42/mmax; bb[1]-=.549/mmax; bb[2]-=.149/mmax; bb[3]+=0./mmax;
    cc[0]-=0.24/mmax; cc[1]+=.139/mmax; cc[2]-=.379/mmax; cc[3]+=0./mmax;
    dd[0]-=.527/mmax; dd[1]+=.117/mmax; dd[2]-=.013/mmax; dd[3]+=.333/mmax;
    ee[0]-=0.176/mmax; ee[1]+=1.005/mmax; ee[2]-=.109/mmax; ee[3]+=0.667/mmax;
    ff[0]-=0.141/mmax; ff[1]-=.138/mmax; ff[2]+=.132/mmax; ff[3]+=0./mmax;


    glClear(GL_COLOR_BUFFER_BIT);
  }
  mm++;

}
/***********************************************************/
void keyboard(unsigned char key, int x, int y){
  switch(key){ 
     case  27: exit(0); break;        /* escape with the  (ESC) key  */ 
     case 'w': glClear(GL_COLOR_BUFFER_BIT); break; /* (W)ipe screen */
   }
}
/***********************************************************/
void idle(void){ glutPostRedisplay(); } 
/***********************************************************/
int main(int argc, char **argv){  /* pure GLUTtery here */ 
  /* loadA(); */
  zeroA();
  glutInitWindowSize(400, 400);        
  glutInit(&argc, argv);
  glutInitDisplayMode(GLUT_RGB); 
  glutCreateWindow("<< Barnsley's Fern in GLUT >>");
  glutDisplayFunc(display);
  glutKeyboardFunc(keyboard);
  glutIdleFunc(idle); 
  glMatrixMode(GL_PROJECTION);
  glLoadIdentity();
  glOrtho(-1,1,0,1.,1.,-1.);
  glMatrixMode(GL_MODELVIEW);
  glLoadIdentity();
  glutMainLoop();
  return 0;             /* ANSI C requires main to return int. */
}
